#include <stdio.h>
#include <stdlib.h>

#include "HWxtest.h"

#include "HWxChrom.h"


int main(int argc, char *argv[])
{
    // input: num alleles, num input, num males, num females, file input, file output
    int nAll, nInput;

    if (argc != 7){
	  printf("Wrong number of parameters!\n");
      exit(-1);
    }
    else {
        nAll = atoi(argv[1]);
        nInput = atoi(argv[2]);
    }


    int rstatID=1; // which statistic to use for histogram (1-4)
    int rhistobins = 0; // number of bins for histogram. (no histogram if 0)
    double rhistobounds[2]= {0,0}; // Two values indicating the range for histogram
    double rhistoData=0; // histogram data. length = histobounds.
    int  rsafeSecs=100; // abort calculation after this many seconds
    double tables=0;


    int *rm = calloc(nAll, sizeof(int));    // alleles A and B + 1
    int mf[2] = {atoi(argv[3]), atoi(argv[4])};   // Number of male and female
    int rk = nAll;
    double robservedVals[4] = {0, 0, 0, 0};
    double rPvals[4] = {0,0,0,0};

    FILE *fin, *fout;

    if ((fin = fopen(argv[5],"r")) == NULL){
       printf("Error! opening file");

       // Program exits if the file pointer returns NULL.
       exit(1);
    }
    if ((fout = fopen(argv[6],"w")) == NULL){
       printf("Error! opening file");

       // Program exits if the file pointer returns NULL.
       exit(1);
    }


    int cnt = 0;
    int j;
    while(cnt != nInput){
        for (j=0; j<nAll;j++){
            fscanf(fin, "%d", &rm[j]);
        }
       fscanf(fin,"%lf", &robservedVals[1]);
       xChrom(rm,
           mf,
            &rk,
            robservedVals, // observed stats: LLR, Prob, U, X2
            rPvals, // computed P values: LLR, Prob, U, X2
            &rstatID, // which statistic to use for histogram (1-4)
            &rhistobins, // number of bins for histogram. (no histogram if 0)
            rhistobounds, // Two values indicating the range for histogram
            &rhistoData, // histogram data. length = histobounds.
            &rsafeSecs, // abort calculation after this many seconds
            &tables // the number of tables examined
            );
        fprintf(fout, "%e\n", rPvals[1]);
        rPvals[1] = 0;
        cnt++;
    }

    fclose(fin);
    fclose(fout);


    return 0;
}

